## mshr 2019.2.0~git20200924.c27eb18+dfsg1

=== CMakeLists.txt ===
# Require CMake 3.5
cmake_minimum_required(VERSION 3.5)

project( MSHR )
set(MSHR_VERSION_RELEASE 0)
set(MSHR_VERSION_MAJOR "2019")
set(MSHR_VERSION_MINOR "2")
set(MSHR_VERSION_MICRO "0")
set(MSHR_VERSION "${MSHR_VERSION_MAJOR}.${MSHR_VERSION_MINOR}.${MSHR_VERSION_MICRO}")
if (NOT MSHR_VERSION_RELEASE)
  set(MSHR_VERSION "${MSHR_VERSION}.dev0")
endif()

# CGAL setup
option(USE_SYSTEM_CGAL "Do not build CGAL, but use an existing build instead." OFF)
if (USE_SYSTEM_CGAL)
  find_package(CGAL 4.12 CONFIG REQUIRED)
endif()

# Borrow some cmake modules from cgal
if (USE_SYSTEM_CGAL)
  set(CMAKE_MODULE_PATH "${CGAL_MODULES_DIR}")
else()
  set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/3rdparty/CGAL/cmake/modules")
endif()

# Add cmake directory to module path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

option(USE_SYSTEM_TETGEN "Do not build tetgen, but use an existing build instead." OFF)
if (USE_SYSTEM_TETGEN)
  find_package(TetGen)
endif()

# Helper macro for testing if particular value is contained in list
# Taken from http://www.cmake.org/Wiki/CMakeMacroListOperations#LIST_CONTAINS
MACRO(LIST_CONTAINS var value)
  SET(${var})
  FOREACH (value2 ${ARGN})
    IF (${value} STREQUAL ${value2})
      SET(${var} TRUE)
    ENDIF (${value} STREQUAL ${value2})
  ENDFOREACH (value2)
ENDMACRO(LIST_CONTAINS)

# Use C++11
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall")

# Boost
# This is workaround to avoid that find_package(Boost)
# picks up th ewrong boost when a hint is given
set(BOOST_ROOT $ENV{BOOST_DIR} $ENV{BOOST_HOME})
if (BOOST_ROOT)
  set(Boost_NO_SYSTEM_PATHS on)
endif()

# Prevent FindBoost.cmake from looking for system Boost{foo}.cmake files
set(Boost_NO_BOOST_CMAKE true)
find_package( Boost REQUIRED system filesystem program_options )
# Save this because it will be overwritten by find_package(DOLFIN)
set(Boost_MSHR_LIBRARIES ${Boost_LIBRARIES})
include_directories("${Boost_INCLUDE_DIRS}")

#  GMP_INCLUDE_DIR       - the GMP include directory
#  GMP_LIBRARIES_DIR     - directory where the GMP libraries are located
#  GMP_LIBRARIES         - Link these to use GMP
find_package(GMP REQUIRED)
include_directories("${GMP_INCLUDE_DIR}")

# Try to find the MPFR libraries
# MPFR_FOUND - system has MPFR lib
# MPFR_INCLUDE_DIR - the MPFR include directory
# MPFR_LIBRARIES_DIR - Directory where the MPFR libraries are located
# MPFR_LIBRARIES - the MPFR libraries
# MPFR_IN_CGAL_AUXILIARY - TRUE if the MPFR found is the one distributed with CGAL in the auxiliary folder
find_package(MPFR REQUIRED)
include_directories("${MPFR_INCLUDE_DIR}")

find_package(Eigen3 REQUIRED)
include_directories("${EIGEN3_INCLUDE_DIR}")

# use CGAL in header-only mode
option (CGAL_HEADER_ONLY "Use CGAL in header-only mode" ON)
if (CGAL_HEADER_ONLY)
  add_definitions( -DCGAL_HEADER_ONLY )
endif()

add_subdirectory(3rdparty)
#include_directories(BEFORE ${CGAL_INCLUDE_DIR})
include_directories(BEFORE ${EXTERNAL_INCLUDE_DIRS})
add_definitions("${EXTERNAL_DEFINITIONS}")

find_package(DOLFIN REQUIRED)
include(${DOLFIN_USE_FILE})

# Set installation directories
set(INSTALL_LIB_DIR lib CACHE PATH "Installation directory for libraries")
set(INSTALL_BIN_DIR bin CACHE PATH "Installation directory for executables")
set(INSTALL_INCLUDE_DIR include CACHE PATH "Installation directory for header files")
set(SHARE_DIR "share/mshr" CACHE PATH "Shared data installation directory.")

# Make relative paths absolute (needed later on)
foreach(p LIB BIN INCLUDE CMAKE)
  set(var INSTALL_${p}_DIR)
  if(NOT IS_ABSOLUTE "${${var}}")
    set(${var} "${CMAKE_INSTALL_PREFIX}/${${var}}")
  endif()
endforeach()


# include for local header directory
include_directories( BEFORE include )

file( GLOB_RECURSE SOURCES src/*.cpp )

add_library(mshr SHARED ${SOURCES})
if (NOT USE_SYSTEM_CGAL)
  add_dependencies( mshr CGAL )
endif()

# Append the library version information to the library target properties
option(MSHR_WITH_LIBRARY_VERSION "Build with library version information." ON)
if (MSHR_WITH_LIBRARY_VERSION)
  string(REPLACE "+" "" MSHR_LIBRARY_VERSION ${MSHR_VERSION})
  # This setting of SOVERSION assumes that any API change
  # will increment either the minor or major version number.
  set(MSHR_LIBRARY_PROPERTIES ${MSHR_LIBRARY_PROPERTIES}
    VERSION ${MSHR_LIBRARY_VERSION}
    SOVERSION ${MSHR_VERSION_MAJOR}.${MSHR_VERSION_MINOR}
  )
endif()
set_target_properties(mshr PROPERTIES ${MSHR_LIBRARY_PROPERTIES})

# Link the executable to (static) CGAL libraries
target_link_libraries( mshr ${GMP_LIBRARIES}
                            ${MPFR_LIBRARIES}
                            tet
                     )

# Fix CGAL's random generator (usefull to reproduce bugs)
option(INIT_CGAL_RANDOM "Use fixed seed for CGAL's pseudo random generator" OFF)
if (INIT_CGAL_RANDOM)
  add_definitions( -DINIT_RANDOM_GENERATOR=0 )
endif()

#
option(ENABLE_EXPERIMENTAL "Enable experimental code" OFF)
if(ENABLE_EXPERIMENTAL)
  message(STATUS "Enabling experimental code")
  add_definitions( -DMSHR_ENABLE_EXPERIMENTAL )
endif()


export(PACKAGE mshr)

target_link_libraries( mshr
  dolfin
  ${Boost_MSHR_LIBRARIES}
  )

# install library
install(TARGETS mshr
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR}
  ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
  )

option(ENABLE_MSHRABLE "Enable building the command line client, mshrable" OFF)
if (ENABLE_MSHRABLE)
  add_executable( mshrable app/mshrable.cpp )

  target_link_libraries( mshrable
    mshr
    dolfin
    ${Boost_MSHR_LIBRARIES}
    )

  # install app
  install(TARGETS mshrable
    RUNTIME DESTINATION ${INSTALL_BIN_DIR}
    LIBRARY DESTINATION ${INSTALL_LIB_DIR}
    ARCHIVE DESTINATION ${INSTALL_LIB_DIR}
    )
else()
    message(STATUS "Disabling building command line client mshrable")
endif()

# install header files
install(DIRECTORY include/ DESTINATION ${INSTALL_INCLUDE_DIR})

file(RELATIVE_PATH REL_INCLUDE_DIR "${INSTALL_CMAKE_DIR}" "${INSTALL_INCLUDE_DIR}")

### add cmake configuration file ###

# common for both config files
set(CONF_EXTERNAL_INCLUDE_DIRS "${DOLFIN_INCLUDE_DIRS};${DOLFIN_3RD_PARTY_INCLUDE_DIRS}")
set(CONF_EXTERNAL_LIBRARIES "${DOLFIN_LIBRARIES};${DOLFIN_3RD_PARTY_LIBRARIES}")
set(CONF_CXX_DEFINITIONS "${DOLFIN_CXX_DEFINITIONS}")
string(REPLACE "\"" "\\\"" CONF_CXX_DEFINITIONS "${CONF_CXX_DEFINITIONS}")
set(CONF_CXX_FLAGS "${DOLFIN_CXX_FLAGS}")

# for the build tree
set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
set(CONF_LIBRARIES_DIRS "${PROJECT_BINARY_DIR}")

configure_file(mshrConfig.cmake.in "${PROJECT_BINARY_DIR}/mshrConfig.cmake" @ONLY)
configure_file(mshr-config.cmake.in "${PROJECT_BINARY_DIR}/mshr-config.cmake" @ONLY)

# ... and for the install tree
set(CONF_INCLUDE_DIRS "${INSTALL_INCLUDE_DIR}")
set(CONF_LIBRARIES_DIRS "${INSTALL_LIB_DIR}")
configure_file(mshrConfig.cmake.in
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshrConfig.cmake" @ONLY)
configure_file(mshr-config.cmake.in
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshr-config.cmake" @ONLY)

# Install the FooBarConfig.cmake and FooBarConfigVersion.cmake
install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshrConfig.cmake" DESTINATION "${INSTALL_LIB_DIR}/cmake/mshr" COMPONENT dev)
install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/mshr-config.cmake" DESTINATION "${INSTALL_LIB_DIR}/cmake/mshr" COMPONENT dev)
#install(FILES "Use-mshr.cmake" DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)





option(ENABLE_TESTS "Enable testing" OFF)

if(ENABLE_TESTS)
  enable_testing()
  add_subdirectory(test)
else()
  message(STATUS "Testing disabled")
endif()

=== 3rdparty/CMakeLists.txt ===
if (NOT USE_SYSTEM_CGAL)
  # Enable ExternalProject CMake module
  include(ExternalProject)
  
  # Set default ExternalProject root directory
  set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_BINARY_DIR}/3rdparty)

  message(STATUS "Building CGAL")
  
  message(STATUS "Current source dir: ${CMAKE_CURRENT_SOURCE_DIR}")
  message(STATUS "Binary dir: ${CMAKE_BINARY_DIR}")
  
  set(CGAL_INSTALL_DIR ${CMAKE_BINARY_DIR}/CGAL-installdir)
  
  if ( CMAKE_BUILD_TYPE )
    set(CGAL_BUILD_TYPE ${CMAKE_BUILD_TYPE})
  else()
    set(CGAL_BUILD_TYPE Debug)
  endif()
  
  # CGAL doesn't allow Developer, RelWithDebInfo and MinSizeRel as build type.
  if ( "${CMAKE_BUILD_TYPE}" STREQUAL "Developer" )
    set(CGAL_BUILD_TYPE "Debug")
  endif()
  if ( "${CMAKE_BUILD_TYPE}" STREQUAL "MinSizeRel"
      OR "${CMAKE_BUILD_TYPE}" STREQUAL "RelWithDebInfo" )
    set(CGAL_BUILD_TYPE "Release")
  endif()
  
  message(STATUS "CGAL build type: ${CGAL_BUILD_TYPE}")
  
  # Note: Need to add fPIC in order to be able to link staticly with CGAL
  # FIXME: The CMAKE_CXX_FLAGS=-std=c++11 is a hack to remove CGAL's dependency on boost.thread (see setup_Boost.cmake)
  # This should be removed when CGAL's boost dependency is eventually removed.
  ExternalProject_Add(CGAL
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/CGAL
    INSTALL_DIR ${CGAL_INSTALL_DIR}
    CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${CGAL_INSTALL_DIR} -DCMAKE_BUILD_TYPE=${CGAL_BUILD_TYPE} -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER} -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER} -DCMAKE_CXX_FLAGS=-std=c++11 -DCGAL_CXX_FLAGS=-fPIC -DWITH_CGAL_Core:BOOL=OFF -DWITH_CGAL_ImageIO:BOOL=OFF -DWITH_CGAL_Qt5:BOOL=OFF -DWITH_demos:BOOL=OFF -DWITH_examples:BOOL=OFF -DWITH_LEDA:BOOL=OFF -DWITH_GMP:BOOL=ON -DWITH_MPFR:BOOL=ON -DWITH_Eigen3:BOOL=ON -DBUILD_SHARED_LIBS:BOOL=OFF -DBOOST_ROOT=${BOOST_ROOT} -DGMP_INCLUDE_DIR=${GMP_INCLUDE_DIR} -DGMP_LIBRARIES=${GMP_LIBRARIES} -DMPFR_INCLUDE_DIR=${MPFR_INCLUDE_DIR} -DMPFR_LIBRARIES=${MPFR_LIBRARIES} -DEIGEN3_INCLUDE_DIR=${EIGEN3_INCLUDE_DIR} -DCGAL_HEADER_ONLY:BOOL=${CGAL_HEADER_ONLY}
    
    # -DWITH_ESBTL:BOOL=OFF        \
    # -DWITH_GMPXX:BOOL=OFF        \
    # -DWITH_IPE:BOOL=OFF          \
    # -DWITH_LAPACK:BOOL=OFF       \
    # -DWITH_LEDA:BOOL=OFF         \
    # -DWITH_MPFI:BOOL=OFF         \
    # -DWITH_NTL:BOOL=OFF          \
    # -DWITH_OpenGL:BOOL=OFF       \
    # -DWITH_OpenNL:BOOL=OFF       \
    # -DWITH_QGLViewer:BOOL=OFF    \
    # -DWITH_RS:BOOL=OFF           \
    # -DWITH_RS3:BOOL=OFF          \
    # -DWITH_TAUCS:BOOL=OFF        \
    # -DWITH_ZLIB:BOOL=OFF         \
    
    UPDATE_COMMAND ""
    )
  
  set(CGAL_INCLUDE_DIR ${CGAL_INSTALL_DIR}/include PARENT_SCOPE)
  set(CGAL_LIB_DIR ${CGAL_INSTALL_DIR}/lib PARENT_SCOPE)
  
  # LINK_DIRECTORIES( ${CGAL_INSTALL_DIR}/lib )
  
  # ADD_LIBRARY(CGAL STATIC IMPORTED)
  # SET_TARGET_PROPERTIES(TARGET cgal PROPERTY
  #     IMPORTED_LOCATION ${CGAL_INSTALL_DIR}/lib/libCGAL.a)
  
  # ADD_LIBRARY(CGAL_Core STATIC IMPORTED)
  # SET_TARGET_PROPERTIES(TARGET cgal PROPERTY
  #     IMPORTED_LOCATION ${CGAL_INSTALL_DIR}/lib/libCGAL_Core.a)
endif()

if (NOT USE_SYSTEM_TETGEN)
  add_subdirectory( tetgen1.5.0 )
endif()

set(EXTERNAL_INCLUDE_DIRS "${CGAL_INSTALL_DIR}/include;${TETGEN_INCLUDE_DIR}" PARENT_SCOPE)
set(EXTERNAL_LIBS "tet" PARENT_SCOPE)
set(EXTERNAL_DEFINITIONS "${TETGEN_DEFINITIONS}" PARENT_SCOPE)

=== debian/control ===
Source: mshr
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Johannes Ring <johannr@simula.no>, Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
 python3-all-dev,
 dh-python,
 python3-setuptools,
 cmake (>= 3.5),
 python3-pybind11 (>= 2.2.2),
 libmpfr-dev,
 libgmp-dev,
 libcgal-dev (>= 4.13),
 libtet1.5-dev,
 libdolfin-dev (>= 2019.2),
 libdolfin64-dev (>= 2019.2.0~git20200218.027d9cc-16),
 python3-ffc (>= 2019.2),
 python3-numpy,
 python3-petsc4py,
 python3-slepc4py,
 python3-petsc4py-real,
 python3-slepc4py-real,
 python3-petsc4py-64-real,
 python3-slepc4py-64-real,
 libproj-dev
Standards-Version: 4.5.1
Homepage: http://fenicsproject.org
Vcs-Git: https://salsa.debian.org/science-team/fenics/mshr.git
Vcs-Browser: https://salsa.debian.org/science-team/fenics/mshr

Package: libmshr2019.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shared libraries for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the shared libraries.

Package: libmshr-dev
Section: libdevel
Architecture: any
Depends: libmshr2019.2 (= ${binary:Version}),
 libmshr-dev-common (= ${binary:Version}),
 libdolfin-dev (>= ${fenics:Upstream-Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Shared links and header files for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the development files, and also the
 utility program mshrable.

Package: libmshr-dev-common
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: python3-ffc (>= ${fenics:Upstream-Version}),
 cmake (>= 2.8.0),
 libproj-dev,
 ${misc:Depends}
Recommends: libmshr-dev (= ${binary:Version}) | libmshr64-dev (= ${binary:Version})
Replaces: libmshr-dev (<< 2019.2.0~git20200213.8895485+dfsg1-3)
Breaks: libmshr-dev (<< 2019.2.0~git20200213.8895485+dfsg1-3)
Description: Shared links and header files for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the common headers and development files.

Package: python3-mshr
Section: python
Architecture: all
Depends: libmshr-dev (>= ${source:Version}),
 python3-mshr-real | python3-mshr64-real,
 python3-dolfin (>= ${fenics:Upstream-Version}),
 dolfin-bin (>= ${fenics:Upstream-Version}),
 python3,
 ${python3:Depends},
 ${misc:Depends}
Description: Python 3 interface for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the common Python 3 interface for mshr, and examples
 and demo programs.
 .
 This is the base package depending on specific mshr builds. By
 default mshr is built against dolfin using the preferred version of PETSc in
 /usr/lib/petsc (with 32-bit indexing), but the alternative version
 (64-bit PETSc) can be selected by setting the environment variable PETSC_DIR.

Package: python3-mshr-real
Section: python
Architecture: any
Depends: libmshr2019.2 (= ${binary:Version}),
 python3-dolfin-real (>= ${fenics:Upstream-Version}),
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: python3-mshr
Description: Python 3 interface for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the Python 3 interface for mshr.

Package: libmshr64-2019.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Shared libraries for mshr with 64-bit indexing
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the shared libraries with support for
 64-bit indexing (libdolfin64 and PETSc-64).

Package: libmshr64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmshr64-2019.2 (= ${binary:Version}),
 libmshr-dev-common (= ${binary:Version}),
 libdolfin64-dev (>= ${fenics:Upstream-Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: Shared links and header files for mshr with 64-bit indexing
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the development files with support for
 64-bit indexing (libdolfin64 and PETSc-64).

Package: python3-mshr64-real
Section: python
Architecture: any
Depends: libmshr64-2019.2 (= ${binary:Version}),
 python3-dolfin64-real (>= ${fenics:Upstream-Version}),
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Recommends: python3-mshr
Description: Python 3 interface for mshr with 64-bit indexing
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the Python 3 interface for mshr with support for
 64-bit indexing (libdolfin64 and PETSc-64).

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1 \
https://bitbucket.org/fenics-project/mshr/downloads/mshr-(.*)\.tar\.gz

## mshr 2019.2.0~git20230811.ff54a68+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 # CGAL setup
 option(USE_SYSTEM_CGAL "Do not build CGAL, but use an existing build instead." OFF)
 if (USE_SYSTEM_CGAL)
-  find_package(CGAL 4.12 CONFIG REQUIRED)
+  find_package(CGAL 5 CONFIG REQUIRED)
 endif()
 
 # Borrow some cmake modules from cgal
@@ -43,8 +43,8 @@
   ENDFOREACH (value2)
 ENDMACRO(LIST_CONTAINS)
 
-# Use C++11
-SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -Wall")
+# Use C++14 to support std:enable_if used by CGAL 5
+set(CMAKE_CXX_STANDARD 14)
 
 # Boost
 # This is workaround to avoid that find_package(Boost)
@@ -158,6 +158,9 @@
   ${Boost_MSHR_LIBRARIES}
   )
 
+# CMAKE_CXX_STANDARD is ignored ;( Need to set standard manually here.
+set_property(TARGET mshr PROPERTY CXX_STANDARD 14)
+
 # install library
 install(TARGETS mshr
   RUNTIME DESTINATION ${INSTALL_BIN_DIR}
@@ -174,6 +177,9 @@
     dolfin
     ${Boost_MSHR_LIBRARIES}
     )
+
+# CMAKE_CXX_STANDARD is ignored ;( Need to set standard manually here.
+set_property(TARGET mshrable PROPERTY CXX_STANDARD 14)
 
   # install app
   install(TARGETS mshrable

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)


# This script is used solely for getting the paths to the dependencies
# of the bindings (ie. pybind11, dolfin and mshr).
# This is written to a json file which is read from setup.py.

PROJECT(mshr_pybind11_config)

# Add cmake directory to mshr module path
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

#   pybind11_FOUND - true if pybind11 and all required components found on the system
#   pybind11_VERSION - pybind11 version in format Major.Minor.Release
#   pybind11_INCLUDE_DIRS - Directories where pybind11 and python headers are located.
#   pybind11_INCLUDE_DIR - Directory where pybind11 headers are located.
#   pybind11_DEFINITIONS - Definitions necessary to use pybind11, namely USING_pybind11.
#   pybind11_LIBRARIES - compile flags and python libraries (as needed) to link against.
#   pybind11_LIBRARY - empty.
#   CMAKE_MODULE_PATH - appends location of accompanying FindPythonLibsNew.cmake and
#                       pybind11Tools.cmake modules.
find_package(pybind11 CONFIG HINTS ${PYBIND11_DIR} ${PYBIND11_ROOT}
  $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})


find_package(DOLFIN)

find_package(mshr MODULE)

configure_file("config.json.in" "config.json")

=== test/CMakeLists.txt ===
# Copyright (C) 2014 Benjamin Kehlet
#
# This file is part of mshr.
#
# mshr is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# mshr is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with mshr.  If not, see <http://www.gnu.org/licenses/>.

# This file defines regression tests. 

# Make sure python finds the mshr module.
# NOTE: Not sure this is the best way. Is saves the environment at "cmake
# time" and applies it when running the test. Changing PYTHONPATH
# later will not have effect. Not sure how to add tp PYTHONPATH at
# runtime.
set(PYTHON_ENVIR "$ENV{PYTHONPATH};DOLFIN_NOPLOT=True")


############# A python program that just imports dolfin and mshr ##############################
add_test("Python-DummyImport" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/dummy.py")
set_property(TEST "Python-DummyImport" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)

############# A union which is particularly prone to roundoff errors ##########################
add_test("Python-DegenerateRemoval" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/degenerate_removal.py")
set_property(TEST "Python-DegenerateRemoval" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)

############# Test the csg operators ##########################################################
add_test("Python-CSGOperators" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-csg.py")
set_property(TEST "Python-CSGOperators" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)

############# Test the fuzzy point map ########################################################
# This test is disabled since the Surface3D class is about to be removed.
#add_test("Python-FuzzyPointMap" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-fuzzypointmap.py")
#set_property(TEST "Python-FuzzyPointMap" PROPERTY
#    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
#)

############# Test the mesh generation ########################################################
add_test("Python-MeshGeneration" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-mesh-generation.py")
set_property(TEST "Python-MeshGeneration" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)

############# Test the predefined meshes ##########################################################
add_test("Python-Meshes" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-meshes.py")
set_property(TEST "Python-Meshes" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)
############# Test the ASCFileReader ##########################################################
add_test("Python-ASCFileReader" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-ASCFileReader.py")
set_property(TEST "Python-ASCFileReader" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)

############# Test the ASCFileReader ##########################################################
add_test("Python-NumSegments2D" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-num-segments-2d.py")
set_property(TEST "Python-NumSegments2D" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)

############# Test the CSG predicates (2D) ##########################################################
add_test("Python-CSGPredicates2D" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-csg-predicates.py")
set_property(TEST "Python-CSGPredicates2D" PROPERTY
  ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
  )

############# Test CSG primitves (2D) ##########################################################
add_test("Python-CSGPrimitives2D" "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/test-csg-primitives-2d.py")
set_property(TEST "Python-CSGPredicates2D" PROPERTY
  ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
)

############# Try meshing some surface files found in the cgal source ########################
# TODO: Print mesh quality measure from program and check the value
set(CGAL_DATA_DIR "${CMAKE_SOURCE_DIR}/3rdparty/CGAL/demo/Polyhedron/data")

# Files that should pass
# Note elephant.off is valid a should passes but takes a very long (so test slave may time out)
set(TESTFILES_VALID "anchor.off;couplingdown.off;cross.off;cube.off;dragknob.off;ellipsoid.off;handle.off;icosahedron.off;joint.off;knot1.off;knot2.off;pinion.off;pipe.off;rotor.off;sphere.off;spool.off;star.off;translated-cube.off;tripod.off")
set(TESTFILES_SELFINTERSECTING "bones.off;cow.off;man.off;oblong.ogg")
set(TESTFILES_NOTCLOSED "cube-ouvert.off;mushroom.off")
set(TESTFILES_NOTTRIANGULAR "pyramid.off")

foreach(CURRENT_DATA_FILE IN LISTS TESTFILES_VALID)
  message(STATUS "Adding test: ${CURRENT_DATA_FILE}")
  add_test(FilePass-cgal-${CURRENT_DATA_FILE} ../mshrable -s -b cgal --check-mesh ${CGAL_DATA_DIR}/${CURRENT_DATA_FILE})
  add_test(FilePass-tetgen-${CURRENT_DATA_FILE} ../mshrable -s -b tetgen --check-mesh ${CGAL_DATA_DIR}/${CURRENT_DATA_FILE})
endforeach(CURRENT_DATA_FILE)


##############  CPP tests
add_executable(cppTestCSGGeometries test-csggeometries.cpp)
target_link_libraries(cppTestCSGGeometries mshr)
add_test(CPP-CSGGeometries cppTestCSGGeometries)


############ Run the demos as regression test ################################################
file(GLOB PYTHONDEMOS "${CMAKE_SOURCE_DIR}/demo/python/*.py")
foreach(CURRENT_DEMO IN LISTS PYTHONDEMOS)
  add_test("PythonDemo-${CURRENT_DEMO}" "${PYTHON_EXECUTABLE}" "${CURRENT_DEMO}")
  set_property(TEST "PythonDemo-${CURRENT_DEMO}" PROPERTY
    ENVIRONMENT "PYTHONPATH=${PYTHON_ENVIR}"
  )

endforeach()

=== debian/changelog ===
mshr (2019.2.0~git20230811.ff54a68+dfsg1-7) unstable; urgency=medium

  * update Build-Depends: libtet-dev for tetgen 1.6
  * debian patch CGAL_6.1_compatibility.diff enables build with CGAL 6.1

 -- Drew Parsons <dparsons@debian.org>  Sun, 05 Oct 2025 22:04:07 +0200

mshr (2019.2.0~git20230811.ff54a68+dfsg1-6) unstable; urgency=medium

  * Add boost_filesystem_extension.patch:
    - Closes: #1110752.
    - Patches app/mshrable.cpp by accessing file extension via
      boost::filesystem.
    - Thanks to Heinrich Schuchardt <heinrich.schuchardt@canonical.com> for
      providing the patch.

 -- Francesco Ballarin <ballarin@debian.org>  Sat, 04 Oct 2025 13:27:06 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-5) unstable; urgency=medium

  * Fix Debian Science Maintainers name [Alexandre Detiste]
  * Update Francesco Ballarin's email address
  * Standards-Version: 4.7.2 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Drop useless get-orig-source target (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Do not parse d/changelog, as suggested by routine-update:
    - Get DEB_VERSION from /usr/share/dpkg/default.mk in d/rules
    - Drop usage of DISTRIBUTION from d/rules: it seems that the variable is not
      actually used anywhere
  * Use secure URI in Homepage field (routine-update)
  * Add missing build dependency on python3-numpy-dev for command dh_numpy3
    (routine-update).
  * watch file standard 4 (routine-update)

 -- Francesco Ballarin <ballarin@debian.org>  Sat, 13 Sep 2025 06:12:51 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-4) unstable; urgency=medium

  * Bump Standards-Version to 4.7.0
  * Force rebuild against OpenMPI 5. Closes: #1086299.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 03 Nov 2024 14:45:53 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-3) unstable; urgency=medium

  * Upload to unstable

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 06 Oct 2024 13:52:13 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-2exp1) experimental; urgency=medium

  * Add Francesco Ballarin to uploaders
  * Add patch CGAL_6_compatibility.diff for compatibility with CGAL 6:
    - bump minum required CGAL version to 6 in cmake
    - require C++17 standard in cmake
    - replace boost::get and assignment to a local variable with CGAL::assign
    Closes: #1074116
  * Build-Depends on libcgal-dev >= 6.0~

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Tue, 25 Jun 2024 12:40:24 +0000

mshr (2019.2.0~git20230811.ff54a68+dfsg1-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Drop unused libproj-dev (build) dependency.

  [ Drew Parsons ]
  * New upstream snapshot.
    - applies debian patches:
      fix_mesh3_internal.patch
      enable_CGAL5_CXX14.patch
      build_CGAL5.patch
      build_CGAL5.6.patch

 -- Drew Parsons <dparsons@debian.org>  Mon, 05 Feb 2024 20:10:04 +0100

mshr (2019.2.0~git20200924.c27eb18+dfsg1-10) unstable; urgency=medium

  * update debian patch build_CGAL5.6.patch for backwards compatibility
    - apply named parameters one-by-one
    - check CGAL version when calling has_Has_features

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Aug 2023 16:23:24 +0200

mshr (2019.2.0~git20200924.c27eb18+dfsg1-9) unstable; urgency=medium

  * make mshr.pth more robust with respect to PETSc installation.
    Use default path if petscconf.h can't be found. Closes: #1000950.
  * debian patch build_CGAL5.6.patch fixes build for CGAL 5.6.
    Named parameters can only be set in CGAL functions.
    Closes: #1043307
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Aug 2023 03:47:17 +0200

mshr (2019.2.0~git20200924.c27eb18+dfsg1-8) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on cmake, libcgal-dev and
      python3-pybind11.
    + libmshr-dev-common: Drop versioned constraint on cmake in Depends.

 -- Drew Parsons <dparsons@debian.org>  Sat, 22 Jul 2023 15:18:42 +0200

=== debian/control ===
Source: mshr
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Johannes Ring <johannr@simula.no>,
           Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <ballarin@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13),
               python3-all-dev,
               dh-python,
               python3-setuptools,
               cmake,
               python3-pybind11,
               libmpfr-dev,
               libgmp-dev,
               libcgal-dev (>= 6.0~),
               libtet-dev,
               libdolfin-dev,
               libdolfin64-dev,
               python3-ffc,
               python3-numpy-dev,
               python3-petsc4py,
               python3-slepc4py,
               python3-petsc4py-real,
               python3-slepc4py-real,
               python3-petsc4py-64-real,
               python3-slepc4py-64-real
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/fenics/mshr
Vcs-Git: https://salsa.debian.org/science-team/fenics/mshr.git
Homepage: https://fenicsproject.org

Package: libmshr2019.2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Shared libraries for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the shared libraries.

Package: libmshr-dev
Architecture: any
Section: libdevel
Depends: libmshr2019.2 (= ${binary:Version}),
         libmshr-dev-common (= ${binary:Version}),
         libdolfin-dev (>= ${fenics:Upstream-Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Shared links and header files for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the development files, and also the
 utility program mshrable.

Package: libmshr-dev-common
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: python3-ffc (>= ${fenics:Upstream-Version}),
         cmake,
         ${misc:Depends}
Recommends: libmshr-dev (= ${binary:Version}) | libmshr64-dev (= ${binary:Version})
Description: Shared links and header files for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the common headers and development files.

Package: python3-mshr
Architecture: all
Section: python
Depends: libmshr-dev (>= ${source:Version}),
         python3-mshr-real | python3-mshr64-real,
         python3-dolfin (>= ${fenics:Upstream-Version}),
         dolfin-bin (>= ${fenics:Upstream-Version}),
         python3,
         ${python3:Depends},
         ${misc:Depends}
Description: Python 3 interface for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the common Python 3 interface for mshr, and examples
 and demo programs.
 .
 This is the base package depending on specific mshr builds. By
 default mshr is built against dolfin using the preferred version of PETSc in
 /usr/lib/petsc (with 32-bit indexing), but the alternative version
 (64-bit PETSc) can be selected by setting the environment variable PETSC_DIR.

Package: python3-mshr-real
Architecture: any
Section: python
Depends: libmshr2019.2 (= ${binary:Version}),
         python3-dolfin-real (>= ${fenics:Upstream-Version}),
         python3-pybind11 (>= ${pybind11:Upstream-Version}),
         python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: python3-mshr
Description: Python 3 interface for mshr
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the Python 3 interface for mshr.

Package: libmshr64-2019.2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Shared libraries for mshr with 64-bit indexing
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the shared libraries with support for
 64-bit indexing (libdolfin64 and PETSc-64).

Package: libmshr64-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmshr64-2019.2 (= ${binary:Version}),
         libmshr-dev-common (= ${binary:Version}),
         libdolfin64-dev (>= ${fenics:Upstream-Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: Shared links and header files for mshr with 64-bit indexing
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the development files with support for
 64-bit indexing (libdolfin64 and PETSc-64).

Package: python3-mshr64-real
Architecture: any
Section: python
Depends: libmshr64-2019.2 (= ${binary:Version}),
         python3-dolfin64-real (>= ${fenics:Upstream-Version}),
         python3-pybind11 (>= ${pybind11:Upstream-Version}),
         python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: python3-mshr
Description: Python 3 interface for mshr with 64-bit indexing
 mshr generates simplicial DOLFIN meshes in 2D and 3D from geometries
 described by Constructive Solid Geometry (CSG) or from surface files,
 utilizing CGAL and Tetgen as mesh generation backends.
 .
 This package contains the Python 3 interface for mshr with support for
 64-bit indexing (libdolfin64 and PETSc-64).

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

MSHR_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS)

# Get DEB_VERSION from /usr/share/dpkg/default.mk
include /usr/share/dpkg/default.mk
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
FENICS_MINOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )

# dolfin depends on the pybind11 version it was built against,
# if pybind11.h will be used in C++ code fragments in python scripts.
# But pybind11 follows semantic versioning, so should have backwards compatibility
# with minor and patch version updates.
# Extract pybind11 version from pybind11-dev
PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
# extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
PYBIND11_X_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\([^.]*\).*/\1/")
PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
PYBIND11_VERSION=$(PYBIND11_X_Y_VERSION)
PYBIND11_NEXT_VERSION=$(shell echo $$(( $(PYBIND11_X_VERSION) + 1 )) )

# extract PETSc version from petsc-dev
PETSC_DEB_VERSION=$(shell dpkg -s petsc-dev | awk '/Version:/ {print $2}')
# extract the current PETSc version
PETSC_UPSTREAM_VERSION=$(shell pkg-config --modversion PETSc)
# "Major" version is the first number in the upstream version (major.minor.release)
PETSC_MAJOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
# "Minor" version is the second number in the upstream version (major.minor.release)
PETSC_MINOR_VERSION=$(shell echo $(PETSC_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
PETSC_VERSION=$(PETSC_MAJOR_VERSION).$(PETSC_MINOR_VERSION)
PETSC_VERSION_NEXT=$(shell echo $(PETSC_MAJOR_VERSION).$$(($(PETSC_MINOR_VERSION)+1)))

SLEPC_UPSTREAM_VERSION=$(shell pkg-config --modversion SLEPc)
# SLEPc version must match PETSc
SLEPC_VERSION=$(PETSC_VERSION)
SLEPC_VERSION_NEXT=$(PETSC_VERSION_NEXT)

PETSC_DIR=/usr/lib/petscdir/petsc$(PETSC_VERSION)/$(DEB_HOST_MULTIARCH)-real
SLEPC_DIR=/usr/lib/slepcdir/slepc$(SLEPC_VERSION)/$(DEB_HOST_MULTIARCH)-real

PETSC64_DIR=/usr/lib/petscdir/petsc64-$(PETSC_VERSION)/$(DEB_HOST_MULTIARCH)-real
SLEPC64_DIR=/usr/lib/slepcdir/slepc64-$(SLEPC_VERSION)/$(DEB_HOST_MULTIARCH)-real

BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
BUILDDIR_64 = obj-$(DEB_HOST_GNU_TYPE)-64

MSHR_LIBDIR = /usr/lib/mshr
MSHR64_LIBDIR = /usr/lib/mshr64

# some arches (mostly 32 bit) don't provide enough memory to build with debug symbols
ARCH_NO_DEBUG_SYMBOLS := armhf i386 mips64el mipsel hppa m68k powerpc x32
ifeq ($(findstring $(DEB_BUILD_ARCH),$(ARCH_NO_DEBUG_SYMBOLS)),)
  MSHR_BUILDFLAGS := $(shell dpkg-buildflags --get CXXFLAGS )
else
# remove -g from build flags on weak arches
  MSHR_BUILDFLAGS := $(shell dpkg-buildflags --get CXXFLAGS | sed 's/-g //' )
endif

CMAKE_OPTS := \
	-D CMAKE_BUILD_TYPE:STRING=Release \
	-D BUILD_SHARED_LIBS:BOOL=ON \
	-D USE_SYSTEM_CGAL:BOOL=ON \
	-D USE_SYSTEM_TETGEN:BOOL=ON \
	-D ENABLE_MSHRABLE:BOOL=ON \
	-D CMAKE_SKIP_RPATH:BOOL=ON \
	-D CMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=OFF \
	-D INSTALL_LIB_DIR:PATH=lib/$(DEB_BUILD_MULTIARCH) \
	-D CMAKE_CXX_FLAGS:STRING="-fpermissive $(MSHR_BUILDFLAGS)" \
	$(MSHR_HOME)

%:
	dh $@ --buildsystem=cmake \
	      --with python3 \
	      --no-parallel

override_dh_auto_clean:
	dh_auto_clean
	rm -rf python/build*
	rm -rf python/mshr.egg-info
	rm -rf debian/tmp64
	rm -rf $(BUILDDIR) $(BUILDDIR_64)

override_dh_auto_configure:
	PETSC_DIR=$(PETSC_DIR) SLEPC_DIR=$(SLEPC_DIR) dh_auto_configure --builddir=$(BUILDDIR) -- $(CMAKE_OPTS)
	PETSC_DIR=$(PETSC64_DIR) SLEPC_DIR=$(SLEPC64_DIR) dh_auto_configure --builddir=$(BUILDDIR_64) -- $(CMAKE_OPTS) -DLIB_NAME_EXT="64" -DDOLFIN_LIB_NAME_EXT="64"

override_dh_auto_build:
	PETSC_DIR=$(PETSC_DIR) SLEPC_DIR=$(SLEPC_DIR) dh_auto_build --builddir=$(BUILDDIR)
	PETSC_DIR=$(PETSC64_DIR) SLEPC_DIR=$(SLEPC64_DIR) dh_auto_build --builddir=$(BUILDDIR_64)

override_dh_auto_install:
	dh_auto_install --builddir=$(BUILDDIR) --destdir=debian/tmp
	dh_auto_install --builddir=$(BUILDDIR_64) --destdir=debian/tmp64
	set -e; \
	for v in $(PYVERS); do \
	   cd python; \
	   PETSC_DIR=$(PETSC_DIR) SLEPC_DIR=$(SLEPC_DIR) \
	   CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr \
	   $$v setup.py build --build-base=$(CURDIR)/python/build-$$v install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
	   PETSC_DIR=$(PETSC64_DIR) SLEPC_DIR=$(SLEPC64_DIR) \
	   CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp64/usr MSHR_LIB_NAME_EXT="64" DOLFIN_LIB_NAME_EXT="64" \
	   $$v setup.py build --build-base=$(CURDIR)/python/build64-$$v install --root=$(CURDIR)/debian/tmp64 --install-layout=deb; \
	   cd ..; \
	done
	dh_numpy3

override_dh_python3-arch:
	dh_python3 -a
	dh_numpy3 -a
	mkdir -p debian/python3-mshr-real/$(MSHR_LIBDIR)
	mv debian/python3-mshr-real/usr/lib/python3  debian/python3-mshr-real/$(MSHR_LIBDIR)
	mkdir -p debian/python3-mshr64-real/$(MSHR64_LIBDIR)
	mv debian/python3-mshr64-real/usr/lib/python3  debian/python3-mshr64-real/$(MSHR64_LIBDIR)

override_dh_gencontrol:
	dh_gencontrol -- -Vfenics:Upstream-Version=$(FENICS_VERSION) \
		-Vpybind11:Upstream-Version=$(PYBIND11_VERSION) -Vpybind11:Next-Upstream-Version=$(PYBIND11_NEXT_VERSION)

# debug symbols (-g) have been switched off in CMAKE_OPTS for some arches, so no point building dbgsym packages
override_dh_strip:
	case " $(ARCH_NO_DEBUG_SYMBOLS) " in \
	    *\ $(DEB_HOST_ARCH)\ *) dh_strip --no-automatic-dbgsym;; \
	    *) dh_strip;; \
	esac

override_dh_dwz:
	case " $(ARCH_NO_DEBUG_SYMBOLS) " in \
	    *\ $(DEB_HOST_ARCH)\ *) echo "skipping dh_dwz since debug symbols (-g) have been switched off for $(DEB_HOST_ARCH)";; \
	    *) dh_dwz;; \
	esac

#override_dh_shlibdeps:
#	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

.PHONY: get-orig-source

=== debian/tests/control ===
Tests: test-mshr-python
Depends: python3-mshr,
	  python3-pytest

Tests: test-mshr64-python,
Depends: python3-mshr64-real,
	  python3-mshr,
	  python3-pytest

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1 \
https://bitbucket.org/fenics-project/mshr/downloads/mshr-(.*)\.tar\.gz
